package ru.dbotthepony.kstarbound.server.network.packets

import ru.dbotthepony.kstarbound.network.IServerPacket
import ru.dbotthepony.kstarbound.server.network.ServerConnection
import java.io.DataInputStream
import java.io.DataOutputStream

data class TrackedSizePacket(val width: Int, val height: Int) : IServerPacket {
	constructor(stream: DataInputStream) : this(stream.readUnsignedByte(), stream.readUnsignedByte())

	init {
		require(width in 1 .. 12) { "Bad chunk width to track: $width" }
		require(height in 1 .. 12) { "Bad chunk height to track: $height" }
	}

	override fun write(stream: DataOutputStream) {
		stream.writeByte(width)
		stream.writeByte(height)
	}

	override fun play(connection: ServerConnection) {
		connection.trackedChunksWidth = width
		connection.trackedChunksHeight = height
	}
}
